/**********************************************************************
 *
 *   FreeDoko a Doppelkopf-Game
 *    
 *   Copyright (C) 2001-2004  by Diether Knof and Borg Enders
 *
 *   This program is free software; you can redistribute it and/or 
 *   modify it under the terms of the GNU General Public License as 
 *   published by the Free Software Foundation; either version 2 of 
 *   the License, or (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details. 
 *   You can find this license in the file 'gpl.txt'.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, 
 *   MA  02111-1307  USA
 *
 *  Contact:
 *    Diether Knof dknof@gmx.de
 *    Borg Enders  borg@borgsoft.de
 *
 **********************************************************************/

#ifdef USE_UI_GTK
#ifndef GTK_PARTY_SETTINGS_GENERAL_HEADER
#define GTK_PARTY_SETTINGS_GENERAL_HEADER

#include "party_settings.h"

#include "widget.h"

namespace GTK_DOKO {
#include <gtk/gtkwidget.h>

  class PartySettings::General {
    public:
      // constructor
      General(PartySettings* const party_settings);
      // destrucotr
      ~General();


      // update the sensitivity
      void sensitivity_update();


      // create a backup
      void backup();
      // destroy the backup
      void backup_destroy();

      // reset the settings
      void reset(); 

      // the variables
      // the variables
      class GTK_GUI& gui(); // the gui
      class PartySettings& party_settings(); // the party settings
      GtkWidget* bookmark(); // the bookmark
      GtkWidget* widget(); // the widget (container)

      // changing of the seed
      static void seed_event(GtkWidget* seed, gpointer general);
      // selected or unselected random seed
      static void seed_random_event(GtkWidget* seed_random, gpointer general);
      // selection of a startplayer
      static void startplayer_event(GtkWidget* startplayer, gpointer general);

      // the random seed is selected/unselected
      void seed_random_set(bool const random);

      // update the widgets
      void update(); 

      // update the language
      void language_update();
    private:
      PartySettings* const party_settings_;

      // backups
      unsigned startseed_bak;
      unsigned startplayer_bak;

      GtkWidget* alignment;

      GtkWidget* seed_frame;
    public:
      GtkWidget* seed_value;
      GtkWidget* seed_random;
    private:

      GtkWidget* startplayer_frame;
      vector<GtkWidget*> startplayer;
      GtkWidget* startplayer_random;

    private: // not to be used
      General();
      General(General const&);
      General& operator=(General const&);
  }; // class PartySettings::General

} // namespace GTK_DOKO

#endif // #ifndef GTK_PARTY_SETTINGS_GENERAL_HEADER
#endif // #ifdef USE_UI_GTK
